commit 7af52b39059b4496b17337d0efc7575f17febb26
Author: Pat Haugen <pthaugen@linux.ibm.com>
Date:   Mon Oct 17 14:53:11 2022 -0500

        Fix register count when not splitting Complex IEEE 128-bit args.
    
        For ABI_V4, we do not split complex args. This created a problem because
        even though an arg would be passed in two VSX regs, we were only advancing the
        function arg counter by one VSX register. Fixed with this patch.
    
        (backported commit 2ee68beee709e48fce85b8892ff9985acc6a91a8)
    
    gcc/
            PR target/99685
            * config/rs6000/rs6000-call.c (rs6000_function_arg_advance_1): Bump
            register count when not splitting IEEE 128-bit Complex.

diff --git a/gcc/config/rs6000/rs6000-call.c b/gcc/config/rs6000/rs6000-call.c
index c910ee5c71a..4e55cbaab55 100644
--- a/gcc/config/rs6000/rs6000-call.c
+++ b/gcc/config/rs6000/rs6000-call.c
@@ -6534,6 +6534,12 @@ rs6000_function_arg_advance_1 (CUMULATIVE_ARGS *cum, machine_mode mode,
 	{
 	  cum->vregno += n_elts;
 
+	  /* If we are not splitting Complex IEEE128 args then account for the
+	     fact that they are passed in 2 VSX regs. */
+	  if (!targetm.calls.split_complex_arg && type
+	      && TREE_CODE (type) == COMPLEX_TYPE && elt_mode == KCmode)
+	    cum->vregno++;
+
 	  if (!TARGET_ALTIVEC)
 	    error ("cannot pass argument in vector register because"
 		   " altivec instructions are disabled, use %qs"

